//**************************************************************************
//! @file eusart_lib.h,v
//!
//! Copyright (c) 2005 Atmel.
//!
//! 쌠ʒmɂĂlicense.txţقǂłB
//!
//! @brief ̧قATMEL̑SĂPWM޲pEUSARTײ ٰ݂̌^ϸۂ
//!		   ܂݂܂B
//!
//! @version 1.8 pwm3-ac-ctrl-motor-0_0_6
//!
//! @todo
//! @bug
//**************************************************************************

#ifndef _EUSART_LIB_H_
#define _EUSART_LIB_H_

#include "lib_mcu/eusart/eusart_drv.h"

//_____ `Ԑݒ ______________________________________________________________

//					| ޯ7: ޯ17
//					| ޯ6: F1617
//					| ޯ5:  ڰݸތ
// eusart_rx_error <  ޯ4: ڰݸތ
//					| ޯ3: ް ްُ݈
//					| ޯ2: è
//					| ޯ1: ~ޯ1
//					| ޯ0: ~ޯ0
extern U8 eusart_rx_error;

//_____ ` __________________________________________________________________

typedef enum encoding_mode {LEVEL, MANCHESTER} t_encoding;
typedef enum bit_order {MSB_FIRST, LSB_FIRST} t_bit_order;
typedef enum parity_type {PARITY_NONE=0x00,PARITY_EVEN=0x20, PARITY_ODD=0x30} t_parity_type;

//_____ 錾 __________________________________________________________________

//_____ ϸ ___________________________________________________________________

//_____ ^ __________________________________________________________________

//--------------------------------------------------------------------------
//  @fn eusart_init
//!
//! EUSART(&USART)Ӌ@\BEUSARTUART̗ؾĂĂ̎Ӌ@\
//! Aċ܂B
//!
//! @warning	Ȃ
//!
//! @param		Ȃ
//!
//! @return		
//!				==TRUE:		֐͎s܂B
//!				==FALSE:	֐͎s܂B
//!
extern Bool eusart_init (U8 nbbit_tx, U8 nbbit_rx, t_encoding mode, \
						 t_bit_order order, U16 fosc, U16 bdr, t_parity_type parity, \
						 U8 stop_tx, U8 stop_rx);

//--------------------------------------------------------------------------
//  @fn eusart_clear
//!
//! EUSART(&USART)Ӌ@\֎~BEUSARTUART̗֎~ASڼ޽
//! (ؾ)l܂B
//!
//! @warning	Ȃ
//!
//! @param		Ȃ
//!
//! @return		Ȃ
//!
extern void eusart_clear(void);

//--------------------------------------------------------------------------
//  @fn eusart_disable
//!
//! EUSART(&USART)Ӌ@\֎~BEUSARTUART̗֎~AMɏՕ
//! ܂B
//!
//! @warning	Ȃ
//!
//! @param		Ȃ
//!
//! @return		Ȃ
//!
extern void eusart_disable(void) ;

//--------------------------------------------------------------------------
//  @fn eusart_enable
//!
//! EUSART(&USART)Ӌ@\BEUSARTUART܂B
//!
//! @warning	ȑO'eusart_init()'sȂ΂Ȃ܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
//--------------------------------------------------------------------------
extern void eusart_enable(void) ;

//--------------------------------------------------------------------------
//  @fn eusart_tx_done
//!
//! ްEUSARTӋ@\ɂđꂽǗ
//!
//! @warning	Ȃ
//!
//! @param		Ȃ
//!
//! @return		Status
//!				==TRUE:		Ms܂B
//!				==FALSE:	Mis
//!
extern Bool eusart_tx_done(void) ;

//--------------------------------------------------------------------------
//  @fn eusart_put
//!
//! EUSARTӋ@\ް𑗐M
//!
//! @warning	Ȃ
//!
//! @param		EUSARToRőoް
//!
//! @return		ް
//!
extern U16 eusart_put(U16 uc_wr_byte) ;

//--------------------------------------------------------------------------
//  @fn eusart_rx_ready
//!
//! ްEUSARTӋ@\ŏǗ
//!
//! @warning	Ȃ
//!
//! @param		Ȃ
//!
//! @return		Status
//!				==TRUE:		ް
//!				==FALSE:	ްȂ
//!
extern Bool eusart_rx_ready(void) ;

//--------------------------------------------------------------------------
//  @fn eusart_get
//!
//! EUSARTӋ@\ް擾A"eusart_rx_error"S̕ϐXV
//!
//! @warning	"eusart_rx_error"ޯč\(ͯގQ)
//!				"return"޲č\
//!
//! @param		Ȃ
//!
//! @return		EUSARTł(Mꂽ)ǂݎް
//!
extern U16 eusart_get(void) ;

//__________________________________________________________________________

#endif // _EUSART_LIB_H_
